<?php
/**************************************************
  Coppermine 1.5.x Plugin - FrameIt $VERSION$=0.2
  *************************************************
  Copyright (c) 2009 Gene F. Young (genefyoung.com)
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ***************************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');


global $CONFIG,$lang_plugin_frameit;
require ('./plugins/frameit/include/init.inc.php');

global $frame_name, $frame_size;

$frameit_superCage = Inspekt::makeSuperCage();

// Add an install action
$thisplugin->add_action('plugin_install','frameit_install');

// Add page_start action for config button
$thisplugin->add_action('page_start','frameit_page_start');

// Add an uninstall action
$thisplugin->add_action('plugin_uninstall','frameit_uninstall');

// Add a configure action
$thisplugin->add_action('plugin_configure','frameit_configure');

// Add filter for displayimage page head
$thisplugin->add_filter('page_meta','frameit_head');

// Add a filter for displayimage body
$thisplugin->add_filter('html_image_reduced','frameit_insert');

// Add filter for Fullsize
$thisplugin->add_filter('fullsize_html', 'frameit_fullsize');

//
// include style stuff in displayimage page header
//
function frameit_head() {        
	global $template_header, $CONFIG;
	global $frame_name, $frame_path, $frame_size;

    get_frame_info();
    
	$frameit_headcode = <<<EOS
	<!-- Begin frameit Headcode -->
	<style type="text/css">
		div.photo { margin: 0px; position: relative; float: right; }
		div.frame_scrapbook img{ margin: 0; padding: 0px; z-index: 1;}
		div.frame_scrapbook { 
			position: relative; margin: {FRAME_SIZE_QUARTER}px; padding-bottom: {FRAME_SIZE_QUARTER}px; padding-right: {FRAME_SIZE_QUARTER}px; z-index: 1;  top: {FRAME_SIZE_QUARTER}px; left: 10px; }
		div.frame_scrapbook div.upper_left {
			background: transparent url('{FRAME_PATH}/{FRAME_NAME}-S-UL.png') no-repeat top left; z-index: 6;
			position: absolute; width: 100%; height: 100%; margin-left: -{FRAME_SIZE_HALF}px; margin-top: -{FRAME_SIZE_HALF}px; padding-right: {FRAME_SIZE_QUARTER}px;	padding-bottom: {FRAME_SIZE_QUARTER}px; top: 0px; left: 0px; }
		div.frame_scrapbook div.upper_right {
			background: transparent url('{FRAME_PATH}/{FRAME_NAME}-S-UR.png') no-repeat top right; z-index: 7;
			position: absolute; width: 100%; height: 100%; margin-right: -{FRAME_SIZE_QUARTER}px; margin-top: -{FRAME_SIZE_HALF}px;	top: 0px; right: 0px; }
		div.frame_scrapbook div.lower_left {
			background: transparent url('{FRAME_PATH}/{FRAME_NAME}-S-LL.png') no-repeat bottom left; z-index: 8;
			position: absolute; width: 100%; height: 100%; margin-left: -{FRAME_SIZE_HALF}px; margin-bottom: -{FRAME_SIZE_QUARTER}px; padding-right: {FRAME_SIZE_QUARTER}px;	bottom: 0px; left: 0px; }
		div.frame_scrapbook div.lower_right {
			background: transparent url('{FRAME_PATH}/{FRAME_NAME}-S-LR.png') no-repeat bottom right; z-index: 9;
			position: absolute; width: 100%; height: 100%; margin-right: -{FRAME_SIZE_QUARTER}px; margin-bottom: -{FRAME_SIZE_QUARTER}px; bottom: 0px; right: 0px; }
	</style>
	<!-- End frameit Headcode -->
EOS;

	$temp = str_replace("{FRAME_NAME}",$frame_name,$frameit_headcode);
    $temp = str_replace("{FRAME_SIZE_QUARTER}",$frame_size/4,$temp);
    $temp = str_replace("{FRAME_SIZE_HALF}",$frame_size/2,$temp);
    $temp = str_replace("{FRAME_PATH}",$frame_path,$temp);

	$template_header = str_replace('{META}','{META}'.$temp,$template_header);

}
//
// frameit function to modify display image body around image
//
function frameit_insert($pic_html) {
	global $frame_size;
	$head = "<table><tr><td align=\"center\">";
	$tail = "</td></tr></table>";
//
// Get contents of image source by looking for <img src= up to end of line 	
//
	preg_match('/(?<tail><img src=.*$)/', $pic_html, $matches);	
	$line_end = $matches[tail];
//
// Get contents of line up to and including ,width= 	
//	
	preg_match('/(?<name>.*,width=)/', $pic_html, $matches);	
	$line_start = $matches[name];
//
// Look for ,width= to extract the width and heigth to add buffering for framing.	
//
	preg_match('/.*,width=(?<width>\d+)\,height=(?<height>\d+)/', $pic_html, $matches);	
	$matches[width] += 120;
	$matches[height] += 120;
	$pic_html = $line_start . $matches[width] . ",height=" . $matches[height] . "')\">" . $line_end;

	$find_1 = "<img src";
	$replace_1 = "<![if gt IE 6]><div class=\"frame_scrapbook\"><![endif]><img src";
//
// add div before image
//
	$return = str_replace($find_1,$replace_1,$pic_html);
//
// add framing before the </a>    
//
	$find_2 = "</a>";
	$replace_2 = <<<EOT
<![if gt IE 6]>
		<div class="upper_left"></div>
		<div class="upper_right"></div>
		<div class="lower_left"></div>
		<div class="lower_right"></div>
	</div>
<![endif]>
<br />
</a>
EOT;
    $return = str_replace($find_2,$replace_2,$return);
//
// now rebuild the html
//
 	$return = $head . $return . $tail;  
    return $return;
}

//
// Add the framing around the fullsize pop image
//
function frameit_fullsize($fullsize_html) {
	global $frame_name, $frame_path, $frame_size;
//
// use our js to adjust the popup window (center inside the popup and center the pop)
//
	$frameit_fs_find1 = '"js/displayimage.fullsize.js"';
	$frameit_fs_replace1 = '"plugins/frameit/frameit.js"';
    $return = str_replace($frameit_fs_find1,$frameit_fs_replace1,$fullsize_html);
//
// add the frame styling
//
	$frameit_fs_find2 = "</style>";

	$frameit_fs_replace2 = <<<EOT
		div.photo { margin: 0px; position: relative; float: right;}
		div.frame_scrapbook img{ margin: 0; padding: 0px; z-index: 1; }
		div.frame_scrapbook {  /*border: thin double #FF0000; */
			position: absolute; margin: {FRAME_SIZE_HALF}px; padding-bottom: {FRAME_SIZE_HALF}px; padding-right: {FRAME_SIZE_HALF}px; z-index: 1; }
		div.frame_scrapbook div.upper_left { /*	 border: thin double #FF0000; */
			background: transparent url('{FRAME_PATH}/{FRAME_NAME}-UL.png') no-repeat top left; z-index: 6;
			position: absolute; width: 100%; height: 100%; margin-left: -{FRAME_SIZE}px; margin-top: -{FRAME_SIZE}px; padding-right: {FRAME_SIZE_HALF}px;	padding-bottom: {FRAME_SIZE_HALF}px; top: 0px; left: 0px; }
		div.frame_scrapbook div.upper_right {
			background: transparent url('{FRAME_PATH}/{FRAME_NAME}-UR.png') no-repeat top right; z-index: 7;
			position: absolute; width: 100%; height: 100%; margin-right: -{FRAME_SIZE_HALF}px; margin-top: -{FRAME_SIZE}px;	top: 0px; right: 0px; }
		div.frame_scrapbook div.lower_left { /*	border: thin double #00ff00; */
			background: transparent url('{FRAME_PATH}/{FRAME_NAME}-LL.png') no-repeat bottom left; z-index: 8;
			position: absolute; width: 100%; height: 100%; margin-left: -{FRAME_SIZE}px; margin-bottom: -{FRAME_SIZE_HALF}px; padding-right: {FRAME_SIZE_HALF}px;	bottom: 0px; left: 0px; }
		div.frame_scrapbook div.lower_right { /*	border: thin double #FFff00; */
			background: transparent url('{FRAME_PATH}/{FRAME_NAME}-LR.png') no-repeat bottom right; z-index: 9;
			position: absolute; width: 100%; height: 100%; margin-right: -{FRAME_SIZE_HALF}px; margin-bottom: -{FRAME_SIZE_HALF}px; bottom: 0px; right: 0px; }   
	</style>
EOT;

    $temp = str_replace("{FRAME_NAME}",$frame_name,$frameit_fs_replace2);
    $temp = str_replace("{FRAME_PATH}",$frame_path,$temp);
    $temp = str_replace("{FRAME_SIZE_HALF}",$frame_size/2,$temp);
    $temp = str_replace("{FRAME_SIZE}",$frame_size,$temp);

    $return = str_replace($frameit_fs_find2,$temp,$return);
//
// Add the start div before the image
//
	$frameit_fs_find3 = '<a href="javascript: window.close()">';
	$frameit_fs_replace3 = '<a href="javascript: window.close()"><![if gt IE 6]><div class="frame_scrapbook" id="frame_scrapbook"><![endif]>';
    $return = str_replace($frameit_fs_find3,$frameit_fs_replace3,$return);
//
// Add the framing around the image
//
	$frameit_fs_find4 = "</a>";
	$frameit_fs_replace4 = <<<EOT
<![if gt IE 6]><div class="upper_left"></div>
		<div class="upper_right"></div>
		<div class="lower_left"></div>
		<div class="lower_right"></div>
	</div>		
<![endif]>
<br />
</a>
EOT;
    $return = str_replace($frameit_fs_find4,$frameit_fs_replace4,$return);

    return $return;
}

// add config button
function frameit_add_config_button($href,$title,$target,$link)
{
  global $template_gallery_admin_menu;
  $new_template = $template_gallery_admin_menu;
  $button = template_extract_block($new_template,'documentation');
  $params = array(
      '{DOCUMENTATION_HREF}' => $href,
      '{DOCUMENTATION_TITLE}' => $title,
      'target="cpg_documentation"' => $target,
      '{DOCUMENTATION_LNK}' => $link,
   );
   $new_button="<!-- BEGIN $link -->".template_eval($button,$params)."<!-- END $link -->\n";
   template_extract_block($template_gallery_admin_menu,'documentation',"<!-- BEGIN documentation -->" . $button . "<!-- END documentation -->\n" . $new_button);
}

function frameit_page_start()
{ 
	global $CONFIG, $lang_plugin_frameit;
	
	if (GALLERY_ADMIN_MODE) {
		frameit_add_config_button('index.php?file=frameit/plugin_config','','',$lang_plugin_frameit['frameit_manager']);
	} 
}
// Install
function frameit_install()
{
	global $CONFIG, $thisplugin;
    require 'include/sql_parse.php';

    // create table
    $db_schema = $thisplugin->fullpath . '/basic.sql';
    $sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
    $sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);
    $sql_query = remove_remarks($sql_query);
    $sql_query = split_sql_file($sql_query, ';');

    foreach($sql_query as $q) { 
      cpg_db_query($q);
		echo $q;
	}
    
    return true;
}

// Unnstall and drop settings table
function frameit_uninstall() {

        global $CONFIG;
        cpg_db_query(" DROP TABLE IF EXISTS {$CONFIG['TABLE_PREFIX']}mod_frameit_frames ");
        cpg_db_query(" DELETE FROM `{$CONFIG['TABLE_PREFIX']}config` WHERE name = 'frameit_selected_frame_id' ");

        return true;
}

function get_frame_info() {

	global $CONFIG;
	global $frame_id, $frame_name, $frame_size, $frame_path;

	$frame_id = $CONFIG['frameit_selected_frame_id'];
	
	$sql = "SELECT * FROM `{$CONFIG['TABLE_PREFIX']}mod_frameit_frames` WHERE `frame_id` = $frame_id ";
	$res = cpg_db_query($sql);
	while ($row = mysql_fetch_assoc($res)){
		$frame_id	= $row['frame_id'];
		$frame_name	= $row['frame_name'];
		$frame_size	= $row['frame_size'];
		$frame_path	= $row['frame_path'];
	}
}	

$frameit_headcode_XXXX = <<<EOS
<!-- Begin frameit Headcode -->
<style type="text/css">
div.photo { margin: 0px; position: relative; float: right; }
div.frame_scrapbook img{ margin: 0; padding: 0px; z-index: 1;}
div.frame_scrapbook { 
	position: relative; margin: 11px; padding-bottom: 11px; padding-right: 11px; z-index: 1;  top: 10px; left: 10px; }
div.frame_scrapbook div.upper_left {
	background: transparent url('plugins/frameit/images/{FRAME_NAME}-S-UL.png') no-repeat top left; z-index: 6;
	position: absolute; width: 100%; height: 100%; margin-left: -12px; margin-top: -12px; padding-right: 11px;	padding-bottom: 11px; top: 0px; left: 0px; }
div.frame_scrapbook div.upper_right {
	background: transparent url('plugins/frameit/images/{FRAME_NAME}-S-UR.png') no-repeat top right; z-index: 7;
	position: absolute; width: 100%; height: 100%; margin-right: -1px; margin-top: -12px;	top: 0px; right: 0px; }
div.frame_scrapbook div.lower_left {
	background: transparent url('plugins/frameit/images/{FRAME_NAME}-S-LL.png') no-repeat bottom left; z-index: 8;
	position: absolute; width: 100%; height: 100%; margin-left: -12px; margin-bottom: -1px; padding-right: 11px;	bottom: 0px; left: 0px; }
div.frame_scrapbook div.lower_right {
	background: transparent url('plugins/frameit/images/{FRAME_NAME}-S-LR.png') no-repeat bottom right; z-index: 9;
	position: absolute; width: 100%; height: 100%; margin-right: -1px; margin-bottom: -1px; bottom: 0px; right: 0px; }
</style>
<!-- End frameit Headcode -->
EOS;

	$frameit_fs_replace2_XXX = <<<EOS
<!-- Begin frameit Headcode -->
<style type="text/css">
div.photo { margin: 0px; position: relative; float: right; }
div.frame_scrapbook img{ margin: 0; padding: 0px; z-index: 1;}
div.frame_scrapbook { 
	position: relative; margin: 11px; padding-bottom: 11px; padding-right: 11px; z-index: 1;  top: 10px; left: 10px; }
div.frame_scrapbook div.upper_left {
	background: transparent url('plugins/frameit/images/{FRAME_NAME}-UL.png') no-repeat top left; z-index: 6;
	position: absolute; width: 100%; height: 100%; margin-left: -12px; margin-top: -12px; padding-right: 11px;	padding-bottom: 11px; top: 0px; left: 0px; }
div.frame_scrapbook div.upper_right {
	background: transparent url('plugins/frameit/images/{FRAME_NAME}-UR.png') no-repeat top right; z-index: 7;
	position: absolute; width: 100%; height: 100%; margin-right: -34px; margin-top: -12px;	top: 0px; right: 0px; }
div.frame_scrapbook div.lower_left {
	background: transparent url('plugins/frameit/images/{FRAME_NAME}-LL.png') no-repeat bottom left; z-index: 8;
	position: absolute; width: 100%; height: 100%; margin-left: -12px; margin-bottom: -1px; padding-right: 11px;	bottom: 0px; left: 0px; }
div.frame_scrapbook div.lower_right {
	background: transparent url('plugins/frameit/images/{FRAME_NAME}-LR.png') no-repeat bottom right; z-index: 9;
	position: absolute; width: 100%; height: 100%; margin-right: -34px; margin-bottom: -1px; bottom: 0px; right: 0px; }
</style>
<!-- End frameit Headcode -->
EOS;

?>