/**************************************************
  Coppermine 1.5.x Plugin - FrameIt $VERSION$=0.2
  *************************************************
  Copyright (c) 2009 Gene F. Young (genefyoung.com)
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ***************************************************/

function adjust_popup()
{
    // Let's build a list of variables that we need to take into account
    var windowWidth = $(window).width();
    var windowHeight = $(window).height();
    var imageWidth = $("#fullsize_image").width();
    var imageHeight = $("#fullsize_image").height();
    var border_buf = 120;
    var border_pad = 22;
    var widthMargin = border_buf;
    var heightMargin = 61 + border_buf;
    var imageRatio = imageWidth/imageHeight;
    var windowRatio = windowWidth/windowHeight;

    var alertString = 'Window width:' + windowWidth + '\n' + 'Window height:' + windowHeight + '\n' + 'Image width:' + imageWidth + '\n' + 'Image height:' + imageHeight;
    if (imageWidth > windowWidth || imageHeight > windowHeight) {
        // The image is larger than the window, so let's resize the image
        if (imageRatio > windowRatio) { // the image width is the culprit
            imageWidth = windowWidth - border_buf;
            imageHeight = imageWidth / imageRatio;
        } else { // the image height is the culprit
            imageHeight = windowHeight - border_buf;
            imageWidth = imageHeight * imageRatio;
        }
    } else {
    	imageWidth -= border_pad;
    	imageHeight -= border_pad;
	} 
    imageWidth = parseInt(imageWidth);
    imageHeight = parseInt(imageHeight);
    $("#fullsize_image").width(imageWidth);
    $("#fullsize_image").height(imageHeight);
    $("#content").width(imageWidth);
    $("#content").height(imageHeight);
    window.resizeTo(imageWidth + widthMargin, imageHeight + heightMargin);
	$("#content").css("position","absolute");
    var tIh = $("#content").height();
    var tWh = $(window).height();
    var tH = ((tWh - tIh) / 2) - border_pad;
	$("#content").css("top",tH);
    var tIw = $("#content").width();
    var tWw = $(window).width();
    var tW = ((tWw - tIw) / 2) - border_pad;
	$("#content").css("left",tW);

    var w, h, fixedW, fixedH, diffW, diffH;
    if (document.documentElement && document.body.clientHeight==0) {     // Catches IE6 and FF in DOCMODE
        w = document.documentElement.clientWidth + 16; // Vert Scrollbar Always On in DOCMODE.
        h = document.documentElement.clientHeight;
        if (w >= screen.availWidth) h += 16;
    } else if (document.all) {
        w = document.body.clientWidth;
        h = document.body.clientHeight;
        if (h >= screen.availHeight) w += 16;
        if (w >= screen.availWidth)  h += 16;
    } else {
        w = window.innerWidth;
        h = window.innerHeight;
        if (w >= screen.availWidth)  h += 16;
        if (h >= screen.availHeight) w += 16;
    }
    w = Math.min(w,screen.availWidth);
    h = Math.min(h,screen.availHeight);
	window.moveTo((screen.availWidth-w)/2, (screen.availHeight-h)/2);
}

$(document).ready(function() {
    adjust_popup();
})